"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  envConfig: () => envConfig
});
module.exports = __toCommonJS(src_exports);
var import_just_safe_set = __toESM(require("just-safe-set"), 1);
var DEFAULT_OPTIONS = {
  prefix: "VITECONFIG_",
  separator: "_"
};
function parseValue(val) {
  if (val === "undefined" || val === void 0) {
    return void 0;
  }
  try {
    return JSON.parse(val);
  } catch (e) {
    return `${val}`;
  }
}
function env2config(options) {
  const { prefix, separator } = options;
  return Object.keys(process.env).filter((key) => key.startsWith(prefix)).map((key) => {
    const path = key.substring(prefix.length).split(separator).join(".");
    const val = parseValue(process.env[key]);
    return { path, val };
  }).reduce((acc, { path, val }) => {
    (0, import_just_safe_set.default)(acc, path, val);
    return acc;
  }, {});
}
function envConfig(inlineOptions) {
  const options = {
    ...DEFAULT_OPTIONS,
    ...inlineOptions
  };
  return {
    name: "vite-plugin-env-config",
    config() {
      const config = env2config(options);
      return config;
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  envConfig
});
//# sourceMappingURL=index.cjs.map